/*
 Storable.java - interface for objects that can be serialized
 
 Copyright  (C) 2004 Hugues Johnson
 
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
 the GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

package com.huguesjohnson.serialization;

/**
 * Storable - interface for objects that can be serialized
 * @author Hugues Johnson
 */
public interface Storable{
	/**
	 * The onDeserialize event should be fired after an object is de-serialized. This allows objects to load transient members, set their working directory, and load Storable members if needed.
	 * @param formatter the formatter to use to load any storable members
	 * @param absoluteDir the working directory since all paths stored in the object should be relative
	 */
	public void onDeserialize(Formatter formatter,String absoluteDir);
}