/*
Tiamat - a role-playing game framework
Selection.java - a representation of a selection on a game menu
    
 Copyright  (C) 2005 Hugues Johnson
 
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.
 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
the GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

package com.huguesjohnson.tiamat;

/** 
 * Selection - a representation of a selection on a game menu.
 * @author Hugues Johnson
 */
public class Selection{
    private String caption;
    /**
     * Returns the caption for this Selection.
     * @return The caption for this Selection.
     */
    public String getCaption(){ return(this.caption); }
    private Event event;
    /**
     * Returns the Event associated with this Selection.
     * @return The Event associated with this Selection.
     */
    public Event getEvent(){ return(this.event); }
    /**
     * Create a new instance of Selection.
     * @param caption The caption for this Selection.
     * @param event The Event associated with this Selection.
     */
    public Selection(String caption,Event event){
        this.caption=caption;
        this.event=event;
    }
}