/*
Tiamat - a role-playing game framework
ProfileDialog.java - dialog for editing a profile element
 
 Copyright  (C) 2004 Hugues Johnson
 
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.
 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
the GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

package com.huguesjohnson.tiamat.tools;

import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Rectangle;
import java.awt.Toolkit;
import javax.swing.JDialog;
import javax.swing.JFrame;

/** ProfileDialog - dialog for editing a profile element
 * an awful lot of this code was generated through the NetBeans 3.6 form editor
 * @author Hugues Johnson
 */
public class ProfileDialog extends JDialog{
    
	/** Determines if a de-serialized file is compatible with this class. See <a href="http://java.sun.com/j2se/1.5.0/docs/guide/serialization/spec/class.html">Java Object Serialization Specifications</a>. */
	private static final long serialVersionUID=3151595834450172520L;
	
	/** Creates new form ProfileDialog */
    public ProfileDialog(Frame parent){
        super(parent,true);
        initComponents();
        //center the window
        if(parent==null){
            this.centerWindow();
        } else{
            this.centerToParent(parent);
        }
    }

    public ProfileDialog(Frame parent, java.lang.String key, java.lang.String value){
        super(parent,true);
        initComponents();
        this.textFieldKey.setText(key);
        this.textFieldValue.setText(value);
        //center the window
        if(parent==null){
            this.centerWindow();
        } else{
            this.centerToParent(parent);
        }
    }    
    
     /** centers the window in the middle of the screen
     */     
     public void centerWindow(){
          Dimension screenDimension=Toolkit.getDefaultToolkit().getScreenSize();
          Rectangle windowDimension=this.getBounds();
          this.setLocation((screenDimension.width-windowDimension.width)/2,(screenDimension.height-windowDimension.height)/2);
     }
     
     /** centers the window in the middle of the screen
     */     
     public void centerToParent(Frame parent){
          Rectangle parentDimension=parent.getBounds();
          Rectangle windowDimension=this.getBounds();
          this.setLocation((parentDimension.width-windowDimension.width)/2,(parentDimension.height-windowDimension.height)/2);
     }     
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        this.panelKey = new javax.swing.JPanel();
        this.labelKey = new javax.swing.JLabel();
        this.textFieldKey = new javax.swing.JTextField();
        this.panelValue = new javax.swing.JPanel();
        this.labelValue = new javax.swing.JLabel();
        this.textFieldValue = new javax.swing.JTextField();
        this.panelButtons = new javax.swing.JPanel();
        this.buttonOk = new javax.swing.JButton();
        this.buttonCancel = new javax.swing.JButton();

        this.getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.Y_AXIS));

        this.setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        this.setTitle("Profile");
        this.setResizable(false);
        this.addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        this.panelKey.setLayout(new javax.swing.BoxLayout(this.panelKey, javax.swing.BoxLayout.X_AXIS));

        this.labelKey.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        this.labelKey.setText("Key: ");
        this.labelKey.setMaximumSize(new java.awt.Dimension(25, 15));
        this.labelKey.setMinimumSize(new java.awt.Dimension(25, 15));
        this.labelKey.setPreferredSize(new java.awt.Dimension(45, 15));
        this.panelKey.add(this.labelKey);

        this.textFieldKey.setToolTipText("Key");
        this.textFieldKey.setMinimumSize(new java.awt.Dimension(160, 21));
        this.textFieldKey.setPreferredSize(new java.awt.Dimension(160, 21));
        this.panelKey.add(this.textFieldKey);

        this.getContentPane().add(this.panelKey);

        this.panelValue.setLayout(new javax.swing.BoxLayout(this.panelValue, javax.swing.BoxLayout.X_AXIS));

        this.labelValue.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        this.labelValue.setText("Value: ");
        this.labelValue.setMaximumSize(new java.awt.Dimension(45, 15));
        this.labelValue.setMinimumSize(new java.awt.Dimension(45, 15));
        this.labelValue.setPreferredSize(new java.awt.Dimension(45, 15));
        this.panelValue.add(this.labelValue);

        this.textFieldValue.setToolTipText("Value");
        this.panelValue.add(this.textFieldValue);

        this.getContentPane().add(this.panelValue);

        this.panelButtons.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

        this.buttonOk.setText("OK");
        this.buttonOk.setToolTipText("Save this profile element");
        this.buttonOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonOkActionPerformed(evt);
            }
        });

        this.panelButtons.add(this.buttonOk);

        this.buttonCancel.setText("Cancel");
        this.buttonCancel.setToolTipText("Cancel");
        this.buttonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonCancelActionPerformed(evt);
            }
        });

        this.panelButtons.add(this.buttonCancel);

        this.getContentPane().add(this.panelButtons);

        this.pack();
    }//GEN-END:initComponents

    public void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        this.closeDialog(true);
    }//GEN-LAST:event_formWindowClosing

    public void buttonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_this.buttonCancelActionPerformed
        this.closeDialog(true);
    }//GEN-LAST:event_this.buttonCancelActionPerformed

    public void buttonOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonOkActionPerformed
        this.closeDialog(false);
    }//GEN-LAST:event_buttonOkActionPerformed

    /** override this in the implementing class */
    public void closeDialog(boolean cancel){
        this.dispose();
        System.exit(0);
    }    
    
    public java.lang.String getKey(){
        return(this.textFieldKey.getText());
    }
    
    public java.lang.String getValue(){
        return(this.textFieldValue.getText());
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        (new ProfileDialog(new JFrame())).setVisible(true);
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buttonCancel;
    private javax.swing.JButton buttonOk;
    private javax.swing.JLabel labelKey;
    private javax.swing.JLabel labelValue;
    private javax.swing.JPanel panelButtons;
    private javax.swing.JPanel panelKey;
    private javax.swing.JPanel panelValue;
    private javax.swing.JTextField textFieldKey;
    private javax.swing.JTextField textFieldValue;
    // End of variables declaration//GEN-END:variables
    
}
